//
// list1.cpp
//
// Version 1.0 
//
// Simple test to load OSM XML into purpose-made OSM classes.  Uses Poco XML classes.
//
// Copyright (c) 2008, Chris Hill.
// All rights reserved.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//
#include <list>
#include <map>
#include <iostream>

#include "osm.h"
#include "osmdata.h"

using namespace std;

int main(int argc, char** argv)
{
	OSMData od;		// create the OSM data object to hold the lists of data
	OSMNode nd;
	OSMWay wy;
	OSMRelation rl;
	OSMRelMember mb;
	list<OSMNode>::iterator NodeIt;	// Iterator for the node list
	list<OSMWay>::iterator WayIt;		// Iterator for the way list
	list<OSMRelation>::iterator RelIt;		// Iterator for the relation list
	
	od.LoadFromFile("Hull.xml");	// load the XML into the OSM lists (the meat of this example)
	
	// display the lists to cout
	 
	cout << "Nodes: " << od.NodeList.size() << endl;
	for (NodeIt=od.NodeList.begin(); NodeIt != od.NodeList.end(); NodeIt++)
	{
		NodeIt->DisplayNode(cout);
	}
	
	cout << "Ways: " << od.WayList.size() << endl;
	for (WayIt=od.WayList.begin(); WayIt != od.WayList.end(); WayIt++)
	{
		WayIt->DisplayWay(cout);
	}
	
	cout << "Relations: " << od.RelList.size() << endl;
	for (RelIt=od.RelList.begin(); RelIt != od.RelList.end(); RelIt++)
	{
		RelIt->DisplayRelation(cout);
	}
	
	return 0;
}
